#!/usr/pkg/bin/ruby

=begin
ZeX - Zinro eXtension

Copyright (C)2006 Hm@PixyGarden.net

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to
deal in the Software without restriction, including without limitation the
rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
sell copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
DEALINGS IN THE SOFTWARE.
=end

$KCODE = 'e'

require 'nkf'
require 'time'
require 'cgi'
require 'erb'
require 'net/http'
require 'open-uri'
require 'logger'
require 'uri'

SOFTWARE_CODE = 'ZeX'
SOFTWARE_ID = '<abbr title="Zinro eXtension">ZeX</abbr>'
SOFTWARE_PAGE = 'http://pixygarden.net/ys/wolf/?p=ZeX'
SOFTWARE_VERSION = '20060926'

SRV_IMG_URI_ABD = 'http://ninjinix.x0.com/img/'
SRV_IMG_URI_CE = 'plugin_wolf/img/'
SRV_IMG_URI_F = 'http://ninjin000.x0.com/wolff_img/'

SRV_1_URI = 'http://ninjinix.x0.com/wolf/index.rb?'  # 
SRV_0_URI = 'http://ninjinel.sakura.ne.jp/wolf/index.rb?'  # ܹ
SRV_A_URI = 'http://ninjinel.x0.com/wolfa/index.rb?'
SRV_B_URI = 'http://ninjinel.x0.com/wolfb/index.rb?'
SRV_C_URI = 'http://ninjinel.x0.com/wolfc/index.rb?'
SRV_D_URI = 'http://ninjin001.x0.com/wolfd/index.rb?'
SRV_E_URI = 'http://ninjin001.x0.com/wolfe/index.rb?'
SRV_F_URI = 'http://ninjin002.x0.com/wolff/index.rb?'

RHTML_DIR = 'view/'
IMG_DIR = RHTML_DIR + 'img/'
LOG_DIR = 'log/'
SOFTWARE_CONFIG_FN = LOG_DIR + 'user.cfg'

$logger = Logger.new(LOG_DIR + SOFTWARE_CODE + '.log', 1)
$logger.progname = SOFTWARE_CODE
$logger.level = Logger::DEBUG

RHTML = {\
	'format' => RHTML_DIR + 'format.rhtml',
	'split' => RHTML_DIR + 'split.rhtml',
	'split_preview' => RHTML_DIR + 'split_preview.rhtml',
	'preview' => RHTML_DIR + 'preview.rhtml',
	'status' => RHTML_DIR + 'status.rhtml',
	'index' => RHTML_DIR + 'index.rhtml',
	'config' => RHTML_DIR + 'config.rhtml',
}

PERSONS = { \
	'01' => ['ŷ', '', ''],
	'02' => ['¼Ĺ', '륿', 'Ĺ'],
	'03' => ['Ϸ', '⡼å', 'Ϸ'],
	'04' => ['', 'ॾ', ''],
	'05' => ['ڤ', 'ȡޥ', ''],
	'06' => ['ι', '˥饹', 'ι'],
	'07' => ['ʤ餺', 'ǥ', ''],
	'08' => ['ǯ', 'ڡ', 'ǯ'],
	'09' => ['', '꡼', '̯'], # ϡ̯פ˰۵Ĥꡣ
	'10' => ['Ծ', 'ӥ', ''],
	'11' => ['ӻ', '', ''],
	'12' => ['ѥ', 'åȡ', ''],
	'13' => ['ǯ', '襢ҥ', ''],
	'14' => ['¼̼', 'ѥ', '̼'],
	'15' => ['', '䥳', ''],
	'16' => ['ɲν', '쥸', ''],
	'17' => ['', 'ե꡼ǥ', ''],
	'99' => ['', '', ''],
}

class ZeX
	class Downloader
		attr_reader :result

		def initialize(vid)
			@vdir = vid
			@vid = vid.gsub(/^[ABCDEF]/, '')
			@result = true
			@config = Config.new
			@user, @pass = '', ''
			Dir.mkdir(LOG_DIR) unless File.exist?(LOG_DIR)
	
			case @vdir 
			when /^A/ then server_uri = SRV_A_URI
			when /^B/ then server_uri = SRV_B_URI
			when /^C/ 
				server_uri = SRV_C_URI
				@user = @config.get('user_id_c')
				@pass = @config.get('password_c')
			when /^D/ then server_uri = SRV_D_URI
			when /^E/ then server_uri = SRV_E_URI
			when /^F/
				server_uri = SRV_F_URI
				@user = @config.get('user_id_f')
				@pass = @config.get('password_f')
			when /\d{3}/ then server_uri = SRV_0_URI
			else
				server_uri = SRV_1_URI
			end
	
			@uri = server_uri + 'vid=' + @vid

			$logger.debug("Downloader: uri => #{@uri}, dir => #{LOG_DIR + @vdir}")
	
			if File.exist?(LOG_DIR + @vdir)
				update
			else
				Dir.mkdir(LOG_DIR + @vdir) 
				download_all
			end
		end
	
		def update
			$logger.debug("Downloader: Updating now...")
			w = get(@uri, LOG_DIR + "#{@vdir}/tmp", true)
			if w
				add_logs = []
	
				ids, msgs = Parser::parse_tmp(@vdir)
				ids = ids - last_ids
				ids.each {|id| add_logs << msgs[id].chomp }
	
				today, uris = get_tmp_info
				$logger.debug("Downloader: Partical?: #{LOG_DIR + @vdir + '/' + today + '.dat'}, #{ids.size}")
				if add_logs == []
					$logger.debug("Downloader: Nothing? add_logs == [] !!")
					# FIXME!!: prolog's announse count in messages?
				elsif File.exist?(LOG_DIR + "#{@vdir}/#{today}.dat") and ids.size < 8  # partical
					$logger.debug("Downloader: #{today} log partical updated...")
					lf = Dir.glob(LOG_DIR + "#{@vdir}/*.dat").sort.last
					add_logs = add_logs.join("\n") + "\n"
					File.open(lf, 'a') {|fh| fh.write add_logs }
				else
					$logger.debug("Downloader: #{today} log partical update failed. Turn to download all...")
					download_all
				end
			else
				$logger.debug("Downloader: Not Updating")
				@result = false
				false
			end
		end
	
		def download_all
			$logger.debug("Downloader: Downloading all now...")
			w = get("#{@uri}&mes=all", LOG_DIR + "#{@vdir}/tmp")
			if w
				today, uris = get_tmp_info
				l = Logs.new(@vdir)
				uris.each {|ary|  # [date, href]
					unless File.exist?(LOG_DIR + "#{@vdir}/.#{ary[0]}.done")
						$logger.debug("Downloader: Updating #{@vdir}/#{ary[0]}...")
						get("#{@uri}&#{ary[1]}", LOG_DIR + "#{@vdir}/#{ary[0]}")
						Parser::parse(@vdir, ary[0])
						touch(LOG_DIR + "#{@vdir}/.#{ary[0]}.done")
						File.unlink(LOG_DIR + "#{@vdir}/#{ary[0]}")
						l.reload
					end
				}
				$logger.debug("Downloader: Downloading all done. Parsing today's log(#{today}).")
				if today == 'end'
					File.unlink(LOG_DIR + "#{@vdir}/tmp")
				else
					if today != "party"
						today = 'day' + today if today !~ /^day/
					end
					File.rename(LOG_DIR + "#{@vdir}/tmp", LOG_DIR + "#{@vdir}/#{today}")
					Parser::parse(@vdir, today)
					File.unlink(LOG_DIR + "#{@vdir}/#{today}")
				end
	
				true
			else
				@result = false
				false
			end
		end
		private :download_all
	
		def get_tmp_info
			ret = NKF.nkf('-ex', File.read(LOG_DIR + @vdir + '/tmp'))
	
			hend = %r(.*<!---<a href="index\.rb\?vid=#{@vid}&amp;cmd=mb">simple</a>--->\n\n\n)m #CF
			hend2 = %r(.*<a href="index\.rb\?vid=#{@vid}&amp;cmd=rss">rss</a>\n)m #D
			fstart = %r(\n+<div class="message">\n.*)m
			ret = ret.gsub(hend, '').gsub(hend2, '').gsub(fstart, '').split("\n")[0]
	
			uris = []
			ret.gsub(%r{<a href="index\.rb\?vid=#{@vid}&amp;(.*?)">}) {
				arg = $1.dup
				case arg
				when /ready/ then uris << ['day0', arg]
				when /party/ then uris << ['party', arg]
				when /(\d)$/ then uris << ['day' + $1.succ, arg]
				end
			}

			today = ''
			ret.gsub(%r{<span class="time">(.*)</span></p>}) {
				td = $1.dup
				case td
				when /(\d)/ then today = 'day' + $1.dup
				when /ԥ/ then today = 'party'
				when /λ/ then today = 'end'
				else
					today = '0'
				end
			}
	
			[today, uris]
		end
		private :get_tmp_info
	
		def last_ids
			logs = Dir.glob(LOG_DIR + "#{@vdir}/*.dat").sort
			lary = []
	
			IO.readlines(logs.last).reverse_each {|line|
				lary << line.split('<>')[0]
			}

			if lary.size < 10
				IO.readlines(logs[logs.size - 2]).reverse_each {|line|
					lary << line.split('<>')[0]
				}
			end
	
			lary[0..9]
		end
		private :last_ids
	
		def get(uri, fp, chk = false)
			if chk
				if need_update?(uri + '&cmd=rss', fp + '.chk')
					_get(uri, fp)
				else
					false
				end
			else
				_get(uri, fp)
			end
		end
		private :get

		def _get(uri, fp)
			act = Action.new('', uri, @user, @pass)
			act.get(fp)
		end
		private :_get

		def need_update?(url, chkfile)
			touch(chkfile) unless File.exist?(chkfile)

			server, path, last, past = '', '', '', File.read(chkfile)
			url.sub(/http:\/\/(.*?)\/(.*)/) { server, path = $1, $2 }
			Net::HTTP.start(server) {|http|
				r = http.head("/#{path}")
				last = Time.parse(r['last-modified']).to_s
			}

			$logger.debug("Downloader: Local file time is #{past}.")
			$logger.debug("Downloader: Remote file time is #{last}.")

			if last == past
				false
			else
				File.open(chkfile, 'w') {|fh| fh.write last }
				true
			end
		end
		private :need_update?
			
		def touch(fp)
			File.open(fp, 'w') {|fh| fh.write '' } unless File.exist?(fp)
		end
		private :touch
	end
	
	class Parser
		def Parser::parse(vid, fp)
			msgs = []
			announce = ''
			d = false
			d = fp.sub(/^day/, '') if fp != 'party'
	
			log = NKF.nkf('-ex', File.read(LOG_DIR + vid + '/' + fp))
			_stock_village_name(vid, log) unless File.exist?(LOG_DIR + vid + '/' + 'name')
			_stock_rolls(vid, log) if fp == 'party'

			# get announce and extra
			announce = _get_extra(d, log)
	
			# delete footer
			log = _delete_footer(log)
	
			# delete header
			if d == '0'  # prolog
				ann_h = %Q(<div class="message">\n<div class="announce">\n)
				ann_f = %Q(</div>\n</div>\n\n)
				hend = %r{#{ann_h}1ܡŷ ȡ\n#{ann_f}}
	
				log.gsub!(/.*#{hend}/m, '')
	
				# delete announce
				log.gsub!(%r{#{ann_h}.*\n#{ann_f}}, '')
			else
				hend = %r{.*<div class="announce">\n.*\n</div>\n</div>\n}m
				log.gsub!(hend, '')
			end
	
			# parse
			ids, msgs = _parse(log, msgs)
	
			#save
			{'.dat' => msgs.join("\n") + "\n", '.ann' => announce}.each {|k, v|
				File.open(LOG_DIR + vid + '/' + fp + k, 'w') {|fh| fh.write v }
			}
		end

		def Parser::_get_extra(d, log)
			alive = '0'
			ae = []

			ann_hash = {}
			%w(newtype vote hunter fortune attack etc).each {|key| ann_hash[key] = []}
	
			log.gsub(%r{<div class="(ann|announce|extra)">\n(.*)\n</div>}) {
				x = $2.dup

				if x !~ /(¸|路|ŷ)/
					ae << x
				elsif x =~ /¸/
					x.gsub(/ (\d+) ̾/) { alive = $1.dup }
				end
			}

			ann = ''
			case d
			when '0'
				log.gsub(/<strong>\d+\/\d+(.*)<\/strong>/) {
					ann << $1 + "\n"
				}
			when '1'
				ae[1].gsub!(/^ɤ餳ˤϡ(.*?)褦$/, '\1')

				ary = ae[1].gsub(/(|̾)/, '').split('')
				ary.each {|j|
					k = ''; j.sub(/(.)$/){ k = $1.dup }
					alive = alive.to_i + k.to_i
					alive = alive.to_s
				}
				ann << ary.join(' ').gsub(/(\d)/, 'x\1') + "\n"

				ann << _anlyse_exe(alive, true)
			else
				ae.each {|x|
					case x
					when //
						ann_hash['newtype'] << x.split(' ')[1]
					when /ɼ/
						ann_hash['vote'] = x.split('<br />')
					when //
						ary = x.split(' ')
						ann_hash['hunter'] << "#{ary[3]} by #{ary[1]}\n"
					when //
						ary = x.split(' ')
						ann_hash['fortune'] << "#{ary[3]} by #{ary[1]}\n"
					when /̵/
						ary = x.split(' ')
						if x =~ /  / # ham melting
							ann_hash['attack'] << "#{ary[1]} #{ary[4]}\n"
						else
							ann_hash['attack'] << "#{x.split(' ')[1]}\n"
						end
					when //
						ann_hash['attack'] << "ߤʤ\n"
					when /ϵ/
						ann_hash['etc'] << x
					end
				}

				ann << _anlyse_votes(ann_hash['vote'])

				%w(hunter fortune attack).each {|x| ann << ann_hash[x].to_s }

				if ann_hash['newtype'] != []
					ann << "#{ann_hash['newtype'].join(' ')}\n"
				end
				if ann_hash['etc'] != []
					ann << "\n\n#{ann_hash['etc'].join}\n\n"
				end

				ann << _anlyse_exe(alive) if d
			end

			ann
		end

		def Parser::_anlyse_votes(ary)
			ret = ''
			votes, exe = {}, ''

			ary.delete('')
			ary.each {|vote|
				vary = vote.split(' ')
				if vote =~ /跺/
					exe = "#{vary[1]}\n"
				else
					votes[vary[4]] = [] unless votes.has_key?(vary[4])
					votes[vary[4]] << vary[1]
				end
			}

			votes.each {|k, v| ret << "#{k}(#{v.size}): #{v.join(' ')}\n" }
			ret << "\n"
			ret << exe if exe != ''
			ret
		end

		def Parser::_anlyse_exe(num, g = false)
			ret = num + ': '
			ary = [num]
		
			i = num.to_i
			if g
				i -= 1
				ary << i.to_s
			end
		
			while i > 4
				i -= 2
				ary << i.to_s
			end

			if g
				ret + ary.join('-') + '-EP x' + (ary.size - 1).to_s
			else
				ret + ary.join('-') + '-EP x' + ary.size.to_s
			end
		end
	
		def Parser::parse_tmp(vid)
			msgs, ids = {}, []
			log = NKF.nkf('-ex', File.read(LOG_DIR + vid + '/tmp'))

			# delete footer and header
			log = _delete_footer(log)
			log.gsub!(%r{.*<a href="index.rb\?vid=\d+&amp;mes=all">ɽ</a>\n}m, '')
	
			_parse(log, msgs)
		end
	
		def Parser::_delete_footer(log)
			ret = log.gsub(/<div class="footer">.*/m, '')
			if ret =~ (%r{<div class="order"})  # in progress
				ret.gsub(/\n{2,3}<div class="message">\n<div class="order">\n.*/m, '')
			else
				ret.gsub(/<a href=.*\n\n<\/div>\n/, '')
			end
		end
	
		def Parser::_parse(log, msgs)
			ids = []
			log.split("</table>\n\n</div>\n").each{|msg|
				x, n, id = [], '', ''
				msg.gsub(/^<a name="mes(\d+)">(.*?)<\/a>/) {
					x << $1
					n = $2.split(' ')[1]
					id = $1.dup
				}
				img_regex = %r{\
					(
					#{SRV_IMG_URI_ABD}|
					#{SRV_IMG_URI_CE}|
					#{SRV_IMG_URI_F}
					)
				}ox

				msg.gsub(/#{img_regex}face(\d\d)\.jpg/){ x << $2 }
				msg.gsub(/#{img_regex}(say|think|whisper|groan)00\.jpg/){ x << $2 }
				msg.gsub(/<span class="time">(.*)<\/span>/){
					t = $1.gsub(/(\s|ʬ)/, '').gsub(//, ':')
					if t.index("")
						t.concat(" AM").gsub!(//, '')
					else
						t.concat(" PM").gsub!(//, '')
					end
					x << Time.parse(t).strftime("%H:%M")
				}
				msg.gsub(/<div class="mes_.*?_body1">(.*)<\/div>$/){ x << $1.dup }
				x << n
				if msgs.class.to_s == 'Array'  # For parse
					msgs << x.join('<>')
				else  # For parse_tmp
					msgs[id.to_s] = x.join('<>')
				end
				ids << id
			}
			return([ids, msgs])
		end
	
		def Parser::_parse_roll(str)
			ret = "<tr><td>#{['', 'ID', '', 'ǽ'].join('</td><td>')}</td></tr>\n"
			str.split('<br />').each {|r|
				r =~ /(.*?) (.*?) (.*?)ˡ(.*?)(.*?)ä/
				ret << "<tr><td>#{[$2, $3, $4, $5].join('</td><td>')}</td></tr>\n"
			}
			
			"<table>\n" + ret + "</table>\n"
		end

		def Parser::_stock_village_name(vid, log)
			log.gsub(/<title>(.*)<\/title>/) {
				File.open(LOG_DIR + vid + '/' + 'name', 'w') {|fh|
					ary = $1.split(' ')
					fh.write ary[1] + ' ' + ary[2]
				}
			}
		end

		def Parser::_stock_rolls(vid, log)
			reg = /<div class="announce">\n(ŷ  .*?ˡ˴¼ͤä.*?)$/
			log.gsub(reg) {
				File.open(LOG_DIR + vid + '/' + 'roll', 'w') {|fh|
					fh.write _parse_roll($1.dup)
				}
			}
		end
	end
	
	class Logs
		def initialize(vid)
			@vid = vid
			@fp = LOG_DIR + "#{@vid}/log"
	
			if File.exist?(@fp)
				@logs = load
			else
				@logs = create
			end
		end
	
		def get_msgs(date, time)
			@logs["#{date}:#{time}"]
		end
	
		def create
			logs = {}
			0.upto(11) {|n|
				if File.exist?(LOG_DIR + "#{@vid}/.day#{n}.done")
					IO.readlines(LOG_DIR + "#{@vid}/day#{n}.dat").each {|line|
						ary = line.chomp.split('<>')
						key = "#{n}:#{ary[3]}"
	
						if logs.has_key?(key)
							logs[key] << ary
						else
							logs[key] = [ary]
						end
					}
				end
			}
			save(logs)
			@logs = logs
		end
		alias :reload :create
	
		def load
			File.open(@fp, 'rb') {|fh|
				Marshal.load(fh.read)
			}
		end
	
		def save(str)
			File.open(@fp, 'wb') {|fh| fh.write Marshal.dump(str) }
		end
		private :save
	end
	
	class View
		attr_reader :out
	
		def initialize(vid, day_id, type_id, sword = false)
			@vid, @d, @t, @s = vid, day_id, type_id, sword
			@config = Config.new
			@emu = RealTimeEmulate.new(vid)
			u = File.read(LOG_DIR + @vid + '/day0.ann').chomp
			@update_time = Time.parse(u.sub(/ ˹/, ''))

			case @vid
			when /^A/ then server_uri = SRV_A_URI
			when /^B/ then server_uri = SRV_B_URI
			when /^C/ then server_uri = SRV_C_URI
			when /^D/ then server_uri = SRV_D_URI
			when /^E/ then server_uri = SRV_E_URI
			when /^F/ then server_uri = SRV_F_URI
			when /\d{3}/ then server_uri = SRV_0_URI
			else
				server_uri = SRV_1_URI
			end

			@uri = server_uri + 'vid=' + vid.gsub(/^[ABCDEF]/, '')
			@logs = Logs.new(@vid)
			fp = LOG_DIR + "#{@vid}/day#{day_id}.dat"
			day_str = day_id + 'D'
			if @d == 'party'
				fp = LOG_DIR + "#{@vid}/party.dat"
				day_str = 'Party '
				@roll = File.read(LOG_DIR + "#{@vid}/roll")
				@castgen = %Q(<p class="castgen"><a href="./?mode=castgen&vid=#{@vid}">wolfbbs.jp ѥ㥹</a></p>)

				base = %Q(./?vid=#{@vid}&day=#{@d}&type=#{@t})
				@regene = %Q(<form action="./">\n<p>\n)
				@regene << %Q(<input type="submit" class="submit" value="ǡƼ" />\n)
				@regene << %Q(<input type="hidden" name="mode" value="reparse" />\n)
				@regene << %Q(<input type="hidden" name="vid" value="#{@vid}" />\n)
				@regene << %Q(<input type="hidden" name="refer" value="#{base}" />\n)
				@regene << %Q(</p>\n</form>\n)
			end
			say_cnt = {}
			PERSONS.each {|k, v|
				say_cnt[v[1]]= {'say' => 0, 'think' => 0, 'whisper' => 0, 'groan' => 0 }
			}
	
			@log, @msgs = [], []
			@persons, @types = [], []
			@title = ''
			@child_hash = {}


			########################## Contents Generating..........
			File.read(fp).each {|line| @log << line.chomp.split('<>') }
			@p_map = {}
			PERSONS.each {|k, v| @p_map[v[1]] = k }
			@log.each {|ary|
				case @d
				when '0' then max = '21'
				when 'party' then max = '600'
				else
					case ary[2]
					when 'think' then max = '5'
					when 'whisper' then max = '40'
					else
						max = '20'
					end
				end
				say_cnt[ary[5]][ary[2]] += 1
	
				@types << ary[2]
				@persons << ary[1]
				body, m_ary = parse_link(ary[4].chomp, ary[0])
				d_str = day_str + ary[3]
				sign =  %Q(#{ary[5]} #{d_str}[#{Time.at(ary[0].to_i).strftime("%S")}])
				sign << %Q((#{say_cnt[ary[5]][ary[2]]}/#{max}))

				if @config.get('groan_img')
					face = @p_map[ary[5]]
				else
					face = ary[1]
				end
	
				@msgs << { \
					'id' => ary[0],
					'person' => ary[1],
					'face' => face,
					'type' => ary[2],
					'body' => body,
					'sign' => sign
				}
	
				if m_ary != [] and m_ary != nil
					m_ary.each {|m|
						key = ary[0] + '_' + m[3].delete(':')  # id + date
						@child_hash[key] = [] unless @child_hash.has_key?(key)
						@child_hash[key] << parse_reference(m, ary[0])
						@msgs << {'type' => 'child', 'id' => key }
					}
				end
			}

			########################## Contents Generating..........
	
			if File.exist?(LOG_DIR + @vid + '/day' + @d + '.ann')
				@announce = File.read(LOG_DIR + @vid + '/day' + @d + '.ann').gsub(/\n/, "<br />\n")
			elsif @d == 'party' and File.exist?(LOG_DIR + @vid + '/' + @d + '.ann')
				@announce = File.read(LOG_DIR + @vid + '/' + @d + '.ann').gsub(/\n/, "<br />\n")
			end
			if File.exist?(LOG_DIR + @vid + '/name')
				@title = File.read(LOG_DIR + @vid + '/name') + "(#{@d.capitalize})"
			end
	
			if type_id
				case type_id
				when 'white'
					@msgs.reject! {|hash| hash['type'] =~ /(whisper|think|groan)/ }
					@child_hash.each {|key, ary|
						ary.reject! {|hash| hash['type'] =~ /(whisper|think|groan)/ }
					}
					@announce.gsub!(/^(|).*/, '')
				when 'whisper'
					@msgs.reject! {|hash| hash['type'] =~ /(think|groan)/ }
					@child_hash.each {|key, ary|
						ary.reject! {|hash| hash['type'] =~ /(think|groan)/ }
					}
					@announce.gsub!(/^(|).*/, '')
				end
			end

		    msg_ids = {}
			@msgs.reject! {|m|
				if m['id'].include?('_') && msg_ids.has_key?(m['id'])
					   true
				else
					   msg_ids[m['id']] = ''
					   false
			   	end
	   		}
	
			if sword
				regex = Regexp.compile(sword)
				@msgs.reject! {|hash|
					hash['body'] !~ regex && hash['type'] != 'child'
				}
				@msgs.each {|hash|
					if hash['type'] != 'child'
						hash['body'].gsub!(regex) {
							'<em class="hilight">' + $&.dup + '</em>'
						}
					end
				}
			end
	
			@pindex = {}
			PERSONS.each {|key, value| @pindex[key]= 1 }

			@pcnt = {}
			PERSONS.each {|key, value| @pcnt[key]= 0 }
			@msgs.each {|msg| @pcnt[msg['person']] += 1 if @pcnt.has_key?(msg['person']) }

			@update = update_generate
			if @update
				@update << bottom_menu_generate
			else
				if @emu.emulating? && @emu.state.last == @d
					@update = %Q(<div id="next"><span><img src="view/img/arrow_right.png" />)
					@update << %Q(<a href="?mode=prt_plus&vid=#{@vid}">1ʤ</a></span></div>)
				else
					d = @d.to_i + 1
					d = 'party' unless File.exist?(LOG_DIR + @vid + "/day#{d}.dat") 
					n = "./?vid=#{@vid}&day=#{d}&type=#{@t}"
					@update = %Q(<div id="next"><a href="#{n}"><img src="view/img/arrow_right.png" />)
					@update << %Q(</a></div>)
				end
			end

			[@types, @persons].each {|ary|
				ary.sort!
				ary.uniq!
			}
			@menu = menu_generate(@types, @persons)
		
			erb = ERB.new(File.read(RHTML['format']))
			@out = erb.result(binding)
		end

		def menu_generate(types, persons)
			r, d, t, p, emulate_state = '', [], [],  [], []
			emulate_state = @emu.state if @emu.emulating?
	
			Dir.glob(LOG_DIR + @vid + '/day*.dat').sort.each {|dat|
				if dat =~ /^#{LOG_DIR + @vid}\/day(\d)\.dat$/
					j = $1.dup
					if j == '0'
						d << _create_menu_link(@d, j, "./?day=#{j}", "ץ")
					elsif @emu.emulating?
						if @emu.state.include?(j)
							if j == '1' or j == '5' or j == '9'
								d << "<li>\n" + _create_menu_link(@d, j, "./?day=#{j}", "#{j}D", false) + ' '
							else
								d << _create_menu_link(@d, j, "./?day=#{j}", "#{j}D", false) + ' '
							end
							d << '</li>' if j == '4' or j == '8'
						end
					else
						if j == '1' or j == '5' or j == '9'
							d << "<li>\n" + _create_menu_link(@d, j, "./?day=#{j}", "#{j}D", false) + ' '
						else
							d << _create_menu_link(@d, j, "./?day=#{j}", "#{j}D", false) + ' '
						end
						d << '</li>' if j == '4' or j == '8'
					end
				end
			}
			d << '</li>' if d.last != '</li>'
			if File.exist?(LOG_DIR + @vid + '/party.dat') && @emu.emulating? == false
				d << _create_menu_link(@d, 'party', "./?day=party", 'ѡƥ')
				d << %Q(<li><img src="view/img/world.png" /> <a href="http://wolfbbs.jp/#{@vid}%C2%BC.html">wolfbbs</a></li>)
			end
			if @emu.emulating?
				d << %Q(<li><a href="?mode=prt_plus&vid=#{@vid}">1ʤ</a></li>)
				d << %Q(<li><a href="?mode=prt_end&vid=#{@vid}">P/RTｪλ</a></li>)
			else
				d << %Q(<li><img src="view/img/chart_curve.png" /> <a href="./?mode=status&amp;vid=#{@vid}">ȯ</a></li>)
			end
	
			whisper = false
			whisper = true if types.include?('whisper')

			unless @emu.emulating?
			t << '<li class="type">['
			t << _create_menu_link(@t, 'white', './?type=white', '¼', false) + ' | '
				t << _create_menu_link(@t, 'whisper', './?type=whisper', 'ϵ', false) + ' | ' if whisper
				t << _create_menu_link(@t, 'all', './?type=all', '', false)
			t << "]</li>\n"
			end
	
			persons.delete('99')
			persons.delete('01')
			p << %Q(<form name="persons">\n<ul>)
			if @config.get('compact_mode')
				n = 0
				persons.each {|person|
					n += 1
					x = ''
					x << %Q(<li>) if n == 1
					x << %Q(<input type="checkbox" name="#{person}" value="#{@pcnt[person]}" onclick="hidden('#{person}');" checked="checked" />)
					x << %Q(<a onclick="checkwithinline('#{person}');">#{PERSONS[person][2]}</a>)
					x << %Q(</li>) if n == 2
					p << x
					n = 0 if n == 2
				}
			else
				persons.each {|person|
					x = %Q(<li>)
					x << %Q(<input type="checkbox" name="#{person}" value="#{@pcnt[person]}" onclick="hidden('#{person}');" checked="checked" />)
					x << %Q(<a onclick="checkwithinline('#{person}');">#{PERSONS[person][1]}</a>)
					x << %Q(</li>)
					p << x
				}
			end
			p << %Q(</ul>\n</form>)
			p << %Q(<p><a href="#" onclick="checkall();">ɽ</a>)
			p << %Q(<a href="#" onclick="decheckall();">ɽ</a></p>)
	
			[d, t].each {|ary| r << "<ul>\n" + ary.join("\n") + "</ul>\n" }
			r << p.join("\n")

			updown =  %Q(<p class="updown"><a href="#top"><img src="view/img/arrow_up.png" alt="Up" /></a> / )
			updown << %Q(<a href="#bottom"><img src="view/img/arrow_down.png" alt="Down" /></a> / )
			updown << %Q(<a href="#" onclick="deathtrap();"></a></p>)

			@s = '' if @s == false

			smenu =  %Q(\n<form action="./" name="search" class="search">\n)
			smenu << %Q(<input type="text" size="15" name="sword" value="#{@s}" />\n)
			smenu << %Q(<input type="hidden" name="vid" value="#{@vid}" />\n)
			smenu << %Q(<input type="hidden" name="day" value="#{@d}" />\n)
			smenu << %Q(<input type="hidden" name="type" value="#{@t}" />\n)
			smenu << %Q(</form>\n)

			r << updown
			r << smenu
			r
		end
		private :menu_generate
	
		def bottom_menu_generate
			x =  %Q(<p class="bottom_menu"><a href="./?mode=split&vid=#{@vid}&day=#{@d}&type=#{@t}">Ϣȯ</a> / )
			x << %Q(<a href="#{@uri}#bottom">ɼå(ϵBBS)</a></p>\n)
		end
		private :bottom_menu_generate

		def url(msg)
			msg.gsub(/((http|https):\/\/[^ۡ<\]\s\n]+)/, '<a href="\1">\1</a>')
		end

	
		def _create_menu_link(date, present, href, content, list = true)
			if date == present
				if list
					%Q(<li>#{content}</li>)
				else
					%Q(#{content})
				end
			else
				if list
					q = %Q(<li><a href="#{href}">#{content}</a></li>)
				else
					q = %Q(<a href="#{href}">#{content}</a>)
				end
				save_link(q)
			end
		end
		private :_create_menu_link
	
		def update_generate
			if @msgs == []
				last_id = ''
			else
				last_id = @msgs.last['id'].sub(/_.*/, '')
			end
			last = Dir.glob(LOG_DIR + "#{@vid}/*.dat").sort.last
			last = last.gsub(%r!^#{LOG_DIR + @vid}/(.*?)\.dat$!, '\1').sub(/day/, '')
			if last == @d
				ret = %Q(<div id="update" onclick="sync();">)
				ret << %Q(<span><img src="view/img/arrow_refresh.png" alt="Update" /></span></div>)
				ret << %Q(<span id="last_id">m#{last_id}</span>)
				ret << %Q(<div id="update_state"></div>)
				ret
			else
				false
			end
		end
		private :update_generate
	
		def parse_reference(ary, ref_id)
			if ary[6] == 'party'
				day_str = 'Party '
			else
				day_str = ary[6] + 'D'
			end
			if @config.get('groan_img')
				face = @p_map[ary[5]]
			else
				face = ary[1]
			end
			{ \
				'id' => ref_id + '_m' + ary[0],
				'person' => ary[1],
				'face' => face,
				'type' => ary[2],
				'body' => ary[4].chomp,
				'sign' =>  %Q(#{ary[5]} #{day_str}#{ary[3]})  # FIXME!!!
			}
		end
	
		def save_link(link)
			link.gsub(%r{<a href="\./\?(.*?)=(.*?)(#.*)*">(.*)</a>}) {
				case $1
				when 'day' then base = %Q(type=#{@t})
				when 'type' then base = %Q(day=#{@d})
				end
				%Q(<a href="./?vid=#{@vid}&#{$1}=#{$2}&#{base}#{$3}">#{$4}</a>)
			}
		end
		private :save_link
	
		def parse_link(str, base_id)
			m_ary = []
	
			s = str.gsub(_get_time_regex) {
	            match_orig = $1.dup
	            match = $1.dup
	
				#begin
					time = parse_time(@d, match)
				#rescue
				#	return(str)
				#end
	
				if match =~ /^\s*(..|.[^:].)$/
					match_orig
				elsif time == false
					match_orig
	
	            elsif time['date'] == @d  # No Date
	                match = time['hour'] + ':' + time['minute']
	                id, stock = '', []

					# present > (update > target => Yesterday) or (target > update => Today)
					# 86400 => 24H
					present = Time.parse(Time.at(base_id.to_i).strftime("%H:%M"))
					update = @update_time.dup
					update -= 86400 if update > present
					#begin
					#	target = Time.parse(match)
					#rescue
					#	return(str)
					#end
					# F587:2D21:27[33]

					pattern = true
					#if present > target
					#	pattern = true  # today
					#else
					#	pattern = false  # yesterday
					#end

					#update -= 86400 if present < update
					#target -= 86400 if update < target
					#p => 09:38
					#u => 15:30 - 1D
					#t => 09:37 - 1D

					if pattern  # Today
						t_ary = []
						@log.each {|ary|
							if ary[3] == match
								unless stock.index(ary[0] + ary[5])
									ary << time['date']
									t_ary << ary
									m_ary << ary
									stock << ary[0] + ary[5]
								end
							end
						}
		
						if t_ary != []
							id = 'm' + t_ary.last[0]
							_matched("##{id}", base_id, time['hour'] + time['minute'], match_orig)
						else
							_nomatch('Today', "#{time['hour']}:#{time['minute']}", match_orig)
						end
					else  # Yesterday
						pd = @d.to_i  - 1
						ary = _get_past_msgs(pd.to_s, time['hour'], time['minute'])

						if ary
							ary.each {|ar| m_ary << ar }
							id = 'm' + m_ary.last[0] if m_ary != []
							_matched("#{pd.to_s}##{id}", base_id, time['hour'] + time['minute'], match_orig)
						else
							_nomatch('Yesterday', "#{pd}d#{time['hour']}:#{time['minute']}", match_orig)
						end
					end
				else  # Past Days
					ary = _get_past_msgs(time['date'], time['hour'], time['minute'])

					if ary
						ary.each {|ar| m_ary << ar }
						id = 'm' + m_ary.last[0] if m_ary != []
						_matched("#{time['date']}##{id}", base_id, time['hour'] + time['minute'], match_orig)
					else
						_nomatch('Past', "#{time['day']}d#{time['hour']}:#{time['minute']}", match_orig)
					end
				end
			}
			[s, m_ary]
		end
		private :parse_link
	
		def parse_time(today, time_str)
			time_str =~ _get_time_regex
	
			d, h, m, date_flag, ampm, ds = $2.dup, $5.dup, $7.dup, $3.dup, '', $6.dup
			ampm = $4 if $4
	
			if date_flag == ''
				h = d + h
				d = ''
			end
			d = (today.to_i - 1).to_s if d == ''
	
			{'' => '0', '' => '1', '' => '2', '' => '3',
			 '' => '4', '' => '5', '' => '6', '' => '7',
			 '' => '8', '' => '9', '' => '0', '' => '1',
			 '' => '2', '' => '3', '' => '4', '' => '5',
			 'ϻ' => '6', '' => '7', 'Ȭ' => '8', '' => '9',
			 '' => '1'}.each {|zen, han|
				[d, h, m].each {|x|
					x.gsub!(/#{zen}/, han)
				}
			}

			if h.size == 1 and m.size == 1 and ds == ''
				return(false)
			end
		
			h = h.to_i + 12 if ampm =~ /(PM|У|)/
			h = h.to_i - 24 if h.to_i >= 24
			return(false) if h.to_i > 23
			h = h.to_s
			h = '0' + h if h.size == 1
			m = '0' + m if m.size == 1
		
			d = today if d == ''
	
			{'date' => d, 'hour' => h.to_s, 'minute' => m, 'ds' => ds }
		end
		private :parse_time

		def _get_time_regex
			rD = /[0-9󻰻͸ϻȬ]/
			rT = /[0-9󻰻͸ϻȬ]/
			rS = /[:;\.\, \-\/]/
			rDS = /[:; h]/
			rDAY = /[d|day|||D|DAY|ġãģ||]/
			rAMPM = /AM||PM|У||/i
			rSPACE = /[:; \-]/

			%r{(
				(#{rD}{0,1}?)(#{rDAY}{0,3})#{rS}{0,1}
				#{rSPACE}*
				(#{rAMPM}*)
				#{rSPACE}*
				(#{rT}{1,2})(#{rDS}{0,2})(#{rT}{1,2})(?:ʬ|m|)*
			)}ixo
		end
		private :_get_time_regex

		def _nomatch(type, target, content)
			%Q{<a href="" class="nomatch" title="No Match(#{type}/#{target})">#{content}</a>}
		end
		private :_nomatch

		def _matched(href, baseid, time, content)
			js =  %Q(onmouseover="popup('m#{baseid}', 'm#{baseid}_#{time}_child')" )
			js << %Q(onmouseout="popup('m#{baseid}', 'm#{baseid}_#{time}_child')")

			if href =~ /^#/
				%Q(<a href="#{href}" #{js}>#{content}</a>)
			else
				save_link(%Q(<a href="./?day=#{href}" #{js}>#{content}</a>))
			end
		end
		private :_matched

		def _get_past_msgs(day, hour, minute)
			msg_ary, stock = [], []
			ary = @logs.get_msgs(day, hour + ':' + minute)
			if ary
				ary.each {|x|
					unless stock.index(x[0] + x[5])
						x << day
						msg_ary << x
						stock << x[0] + x[5]
					end
				}

				msg_ary
			else
				return(false)
			end
		end
		private :_get_past_msgs
	end

	class RealTimeEmulate
		attr_reader :state

		def initialize(vid)
			@vid = vid
			@fn = LOG_DIR + @vid + '/.emu'
			@emulating = File.exist?(@fn)
			@state = File.read(@fn).chomp.split(',') if @emulating
		end

		def emulating?
			@emulating
		end

		def start
			File.open(@fn, 'w') {|fh| fh.write('1') }
		end

		def quit
			File.unlink(@fn)
		end

		def plus
			ary = File.read(@fn).chomp.split(',')
			x = ary.last.succ
			if File.exist?(LOG_DIR + @vid + "/day#{x}.dat")
				ary << x
				File.open(@fn, 'w') {|fh| fh.write ary.join(',') }
			else  # party
				quit
				x = 'party'
			end
			x
		end
	end

	class Action
		attr_reader :uri_orig

		def initialize(vid, url, user, pass)
			@vid = vid
			@uri_orig = url
			@uri = URI.parse(url)
			h =  %Q({"user_id"%3D>"#{user}"%2C%20)
			h << %Q("password"%3D>"#{pass}"})
			@head = {'User-Agent' => "#{SOFTWARE_CODE} (#{SOFTWARE_VERSION})"}
			@head['Cookie'] = 'login=' + CGI.escape(h) if user != ''
		end

		def get(fp)
			$logger.debug("#{@uri_orig}")
			if @head.has_key?('Cookie')
				f = OpenURI.open_uri(@uri_orig,
					'User-Agent' => @head['User-Agent'],
					'Cookie' => @head['Cookie']
				)
			else
				f = OpenURI.open_uri(@uri_orig,
					'User-Agent' => @head['User-Agent']
				)
			end
			File.open(fp, 'w') {|fh| fh.write f.read }
			true
		end
	
		def post(message, style)
			res = nil
			msg = CGI.escape(NKF.nkf('-sx', message))
			data =  "vid=#{@vid}&cmd=write&pid=&skill="
			data << "&style=#{style}&message=#{msg}"
			#Net::HTTP.start(@uri.host, @uri.port) {|http|
			#	res = http.post(@uri.path, data, @head)
			#}
			# PASS/UID ǧΤߡȯ¤ȤϸƤʤ
			#if res.code == '302'
			#	true
			#else
				false
			#end
		end
	
		def post_say(msg); post(msg, 'say'); end
		def post_think(msg); post(msg, 'think'); end
		def post_whisper(msg); post(msg, 'whisper'); end
	end

	class Splitter
		require 'jcode'

		attr_reader :out

		def initialize(body = '', vid = '', day = '', type = '')
			@config = Config.new
			@body, @vid, @day, @type = body, vid, day, type
			if body != ''
				str = body.dup
				ret = []
				loop {
					tmp = ''
					tmp_base = ''
					if str =~ /(.{0,200})/em
						tmp = $1.dup
						tmp_base = tmp.dup
						tmp = tmp.strip
						if tmp =~ /((.*?\r\n){5})/m
							tmp = $1.dup
							tmp_base = tmp
						end
						if tmp =~ /(.*?\r\n\-\-\r\n)/m
							tmp = $1.dup
							tmp_base = tmp
						end
						ret << tmp
						str[0, tmp_base.length] = ''
					end
					break if str == ''
				}
				cnt_ary = []
				ret.collect! {|x|
					s = x.strip.gsub(/^\-\-\Z/, '').gsub(/^\-\-\r\n/, '')
					s.strip.gsub(/^\-\Z/, '').gsub(/^\-\r\n/, '').strip
				}
				ret.reject! {|x| x.strip == '' }
				ret.each {|x| cnt_ary << x.jlength }
				@out = ret.join("\n--\n")  + "\n--"

				n = 0
				@out.gsub!(/^--$/) {
					n += 1
					' ' + n.to_s + ' (' + cnt_ary[n-1].to_s + ')'
				}
				avg_base = 0
				cnt_ary.each {|c| avg_base += c }
				avg = avg_base / n
				@status = " #{n.to_s} ȯ (̩: #{avg.to_s} / ʸ: #{avg_base.to_s}): "
				@status << cnt_ary.join('/')
			else
				@out = ''
			end
		end

		def input
			erb = ERB.new(File.read(RHTML['split']))
			erb.result(binding)
		end

		def to_a
			ary = []
			@out.gsub(/(.*?) (\d+) \((\d+)\)/m) { ary << $1.dup }
			ary
		end

		def response
			hash = {}
			@out.gsub(/(.*?) (\d+) \((\d+)\)/m) {
				n, m = $2.to_i, $3.dup
				c = $1.gsub(/\r\n/, '<br />').gsub(/^<br \/>/, '').gsub(/<br \/>$/, '')
				l = 1
				c.gsub(/<br \/>/) { l += 1 }
				c = CGI.escapeHTML(c)
				c.gsub!(/\&lt;br \/\&gt;/, '<br />')

				hash[n] = [c, m, l]
			}
			erb = ERB.new(File.read(RHTML['split_preview']))
			erb.result(binding)
		end

		def preview(say_type)
			@logs = Logs.new(@vid)
			@p_map = {}
			base_body = CGI.escape(@body)
			PERSONS.each {|k, v| @p_map[v[1]] = k }
			post_limit = 0

			ary = []
			child_hash = {}
			@out.gsub(/(.*?) (\d+) \((\d+)\)/m) {
				n, m = $2.to_i, $3.dup
				c = $1.gsub(/\r\n/, '<br />').gsub(/^<br \/>/, '').gsub(/<br \/>$/, '')
				l = 1
				c.gsub(/<br \/>/) { l += 1 }

				body, m_ary = parse_link(c, n.to_s)
				ary << [body, m, l]
				post_limit += 1

				if m_ary != [] and m_ary != nil
					m_ary.each {|m|
						key = n.to_s + '_' + m[3].delete(':')  # id + date
						child_hash[key] = [] unless child_hash.has_key?(key)
						child_hash[key] << parse_reference(m, n.to_s)
						ary << ['child', key, '']
					}
				end
			}

            msg_ids = {}
            ary.reject! {|m|
                if m[1].include?('_') && msg_ids.has_key?(m[1])
                       true
                else
                       msg_ids[m[1]] = ''
                       false
                end
            }

			if say_type
				case say_type
				when 'html'
					child_hash.each {|k, a|
						a.reject! {|h| h['type'] =~ /(whisper|think)/ }
					}
				when 'whisper'
					child_hash.each {|k, a|
						a.reject! {|h| h['type'] =~ /think/ }
					}
				end
			end

			post_limit = post_limit * 20
			erb = ERB.new(File.read(RHTML['preview']))
			erb.result(binding)
		end

		def parse_reference(ary, ref_id)
			if ary[6] == 'party'
				day_str = 'Party '
			else
				day_str = ary[6] + 'D'
			end
			if @config.get('groan_img')
				face = @p_map[ary[5]]
			else
				face = ary[1]
			end
			{ \
				'id' => ref_id + '_m' + ary[0],
				'person' => ary[1],
				'face' => face,
				'type' => ary[2],
				'body' => ary[4].chomp,
				'sign' =>  %Q(#{ary[5]} #{day_str}#{ary[3]})  # FIXME!!!
			}
		end

		def save_link(link)
			link.gsub(%r{<a href="\./\?(.*?)=(.*?)(#.*)*">(.*)</a>}) {
				case $1
				when 'day' then base = %Q(type=#{@t})
				when 'type' then base = %Q(day=#{@day})
				end
				%Q(<a href="./?vid=#{@vid}&#{$1}=#{$2}&#{base}#{$3}">#{$4}</a>)
			}
		end
		private :save_link

		def parse_link(str, base_id)
			m_ary = []
	
			s = str.gsub(_get_time_regex) {
	            match_orig = $1.dup
	            match = $1.dup
	
				#begin
					time = parse_time(@d, match)
				#rescue
				#	return(str)
				#end
	
				if match =~ /^\s*(..|.[^:].)$/
					match_orig
				elsif time == false
					match_orig
	
	            elsif time['date'] == @d  # No Date
	                match = time['hour'] + ':' + time['minute']
	                id, stock = '', []

					pattern = true  # see View#parse_link

					if pattern  # Today
						ary = _get_past_msgs(@day, time['hour'], time['minute'])

						if ary
							ary.each {|ar| m_ary << ar }
							id = 'm' + m_ary.last[0] if m_ary != []
							_matched("#{@day}##{id}", base_id, time['hour'] + time['minute'], match_orig)
						else
							_nomatch('Today', "#{@day}d#{time['hour']}:#{time['minute']}", match_orig)
						end
					else  # Yesterday
						pd = @d.to_i  - 1
						ary = _get_past_msgs(pd.to_s, time['hour'], time['minute'])

						if ary
							ary.each {|ar| m_ary << ar }
							id = 'm' + m_ary.last[0] if m_ary != []
							_matched("#{pd.to_s}##{id}", base_id, time['hour'] + time['minute'], match_orig)
						else
							_nomatch('Yesterday', "#{pd}d#{time['hour']}:#{time['minute']}", match_orig)
						end
					end
				else  # Past Days
					ary = _get_past_msgs(time['date'], time['hour'], time['minute'])

					if ary
						ary.each {|ar| m_ary << ar }
						id = 'm' + m_ary.last[0] if m_ary != []
						_matched("#{time['date']}##{id}", base_id, time['hour'] + time['minute'], match_orig)
					else
						_nomatch('Past', "#{time['day']}d#{time['hour']}:#{time['minute']}", match_orig)
					end
				end
			}
			[s, m_ary]
		end
		private :parse_link
	
		def parse_time(today, time_str)
			time_str =~ _get_time_regex
	
			d, h, m, date_flag, ampm, ds = $2.dup, $5.dup, $7.dup, $3.dup, '', $6.dup
			ampm = $4 if $4
	
			if date_flag == ''
				h = d + h
				d = ''
			end
			d = (today.to_i - 1).to_s if d == ''
	
			{'' => '0', '' => '1', '' => '2', '' => '3',
			 '' => '4', '' => '5', '' => '6', '' => '7',
			 '' => '8', '' => '9', '' => '0', '' => '1',
			 '' => '2', '' => '3', '' => '4', '' => '5',
			 'ϻ' => '6', '' => '7', 'Ȭ' => '8', '' => '9',
			 '' => '1'}.each {|zen, han|
				[d, h, m].each {|x|
					x.gsub!(/#{zen}/, han)
				}
			}

			if h.size == 1 and m.size == 1 and ds == ''
				return(false)
			end
		
			h = h.to_i + 12 if ampm =~ /(PM|У|)/
			h = h.to_i - 24 if h.to_i >= 24
			return(false) if h.to_i > 23
			h = h.to_s
			h = '0' + h if h.size == 1
			m = '0' + m if m.size == 1
		
			d = today if d == ''
	
			{'date' => d, 'hour' => h.to_s, 'minute' => m, 'ds' => ds }
		end
		private :parse_time

		def _get_time_regex
			rD = /[0-9󻰻͸ϻȬ]/
			rT = /[0-9󻰻͸ϻȬ]/
			rS = /[:;\.\, \-\/]/
			rDS = /[:; h]/
			rDAY = /[d|day|||D|DAY|ġãģ||]/
			rAMPM = /AM||PM|У||/i
			rSPACE = /[:; \-]/

			%r{(
				(#{rD}{0,1}?)(#{rDAY}{0,3})#{rS}{0,1}
				#{rSPACE}*
				(#{rAMPM}*)
				#{rSPACE}*
				(#{rT}{1,2})(#{rDS}{0,2})(#{rT}{1,2})(?:ʬ|m|)*
			)}ixo
		end
		private :_get_time_regex

		def _nomatch(type, target, content)
			%Q{<a href="" class="nomatch" title="No Match(#{type}/#{target})">#{content}</a>}
		end
		private :_nomatch

		def _matched(href, baseid, time, content)
			js =  %Q(onmouseover="popup('m#{baseid}', 'm#{baseid}_#{time}_child')" )
			js << %Q(onmouseout="popup('m#{baseid}', 'm#{baseid}_#{time}_child')")

			if href =~ /^#/
				%Q(<a href="#{href}" #{js}>#{content}</a>)
			else
				save_link(%Q(<a href="./?day=#{href}" #{js}>#{content}</a>))
			end
		end
		private :_matched

		def _get_past_msgs(day, hour, minute)
			msg_ary, stock = [], []
			ary = @logs.get_msgs(day, hour + ':' + minute)
			if ary
				ary.each {|x|
					unless stock.index(x[0] + x[5])
						x << day
						msg_ary << x
						stock << x[0] + x[5]
					end
				}

				msg_ary
			else
				return(false)
			end
		end
		private :_get_past_msgs
	end

	class CastGen
		attr_reader :out
	
		def initialize(vid)
			@vid = vid
			@phash = get_ann
			@config = Config.new
	
			ret = "|LEFT:~|LEFT:~|LEFT:~ü|LEFT:~|LEFT:~|LEFT:~|h\n"
	
			all = []
			get_base().each {|ar|
				ar[2] = get_person_state(ar[0])
				all << ar
			}

			all.reject! {|x| x[0] == '' }
			all.reject! {|x| x == nil }
			all.sort! {|a, b|
				if a[0] == ''
					-1
				elsif b[0] == ''
					1
				elsif a[2][0] != b[2][0]
					a[2][0] <=> b[2][0]
				else
					if a[2][1] != b[2][1]
						if a[2][1] == '跺'
							case b[2][1]
							when '' then -1
							when '' then 1
							end
						elsif a[2][1] == ''
							case b[2][1]
							when '跺' then 1
							when '' then 1
							end
						elsif a[2][1] == ''
							case b[2][1]
							when '' then -1
							when '跺' then -1
							end
						end
					else
						a[3] <=> b[3]
					end
				end
			}
	
			all.each {|ary|
				name = ary.shift
				user_id = ary.shift
				status = ary.shift
				user_skill = ary.shift
				name_ary = []
				PERSONS.each {|k, v| name_ary = [v[0], name] if v[1] == name }
				name = 'CENTER:' + name_ary.join('&br;')
			
				x = []
				x << roll(name_ary[0], name_ary[1])
				x << name
				x << '[[' + user_id + ']]'
				x << death(status[0], status[1])
				x << skill(user_skill)
				x << ''
				ret << '|' + x.join('|') + "|\n"
			}
	
			@out = ret
		end
	
		def skill(sk)
			case sk
			when '¼'
				"&ref(#{_skill_url('00')}, nolink, #{sk});"
			else
				skills = {\
					'ϵ' => ['01', 'ffcccc'],
					'ꤤ' => ['02', 'ccffff'],
					'ǽ' => ['03', 'ccccff'],
					'' => ['04', 'ffccff'],
					'' => ['05', 'ccffcc'],
					'ͭ' => ['06', 'ffffcc'],
					'ϥॹʹ' => ['07', 'cc9966'],
				}
				no = skills[sk][0]
				c = skills[sk][1]
		
				"#{_skill_color(c)}&ref(#{_skill_url(no)},nolink,#{sk});"
			end
		end
		
		def _skill_color(color)
			"BGCOLOR(##{color}):"
		end
		
		def _skill_url(no)
			if no == '07'
				"http://ninjin001.x0.com/wolfe/plugin_wolf/img/skill07.jpg"
			else
				"http://ninjinix.x0.com/wolf/plugin_wolf/img/skill#{no}.jpg"
			end
		end
		
		def roll(r, name)
			rolls = {}
			PERSONS.each {|key, value| rolls[value[1]] = key }
			no = rolls[name]
			x = "&ref(http://ninjinix.x0.com/wolf/plugin_wolf/img/face#{no}.jpg"
			x << ",#{r} #{name});"
		end
		
		def death(d, type)
			case type
			when ''
				if @config.get('cast_attack_color') == ''
					"CENTER:BGCOLOR(#{@config.get('cast_attack_bgcolor')}):#{d}&br;"
				else
					"CENTER:BGCOLOR(#{@config.get('cast_attack_bgcolor')}):&color(#{@config.get('cast_attack_color')}){#{d}&br;};"
				end
			when '跺'
				if @config.get('cast_exe_color') == ''
					"CENTER:BGCOLOR(#{@config.get('cast_exe_bgcolor')})#{d}&br;跺"
				else
					"CENTER:BGCOLOR(#{@config.get('cast_exe_bgcolor')}):&color(#{@config.get('cast_attack_bgcolor')}){#{d}&br;跺};"
				end
			when ''
				if @config.get('cast_newtype_color') == ''
					"CENTER:BGCOLOR(#{@config.get('cast_newtype_bgcolor')}):#{d}&br;"
				else
					"CENTER:BGCOLOR(#{@config.get('cast_newtype_bgcolor')}):&color(#{@config.get('cast_newtype_bgcolor')}){#{d}&br;};"
				end
			when '¸'
				if @config.get('cast_alive_color') == ''
					"CENTER:BGCOLOR(#{@config.get('cast_alive_bgcolor')}):¸"
				else
					"CENTER:BGCOLOR(#{@config.get('cast_alive_bgcolor')}):&color(#{@config.get('cast_alive_bgcolor')}){¸};"
				end
			end
		end
	
		def get_base
			roll = IO.readlines(LOG_DIR + @vid + '/' + 'roll')
			roll.pop
			roll.shift
			
			ary = []
			roll.each {|line|
				line.chomp!
				line.gsub!(/<\/td>/, '')
				l = line.split('<td>').map {|x| x.gsub(/<.*?>/, '') }
				l.shift
				ary << l
			}
			ary
		end
	
		def get_ann
			phash = {}
			PERSONS.each {|key, value| phash[value[1]]= [] }
	
			last = 0
			Dir.entries(LOG_DIR + @vid + '/').sort.each {|fp|
				if fp =~ /day(\d+)\.ann$/ 
					day = $1.dup.to_i
					s = File.read(LOG_DIR + @vid + '/' + fp)
					{'' => '跺', '' => '', '' => ''}.each {|dtype, dvalue|
						if s.index(dtype)
							s.gsub(/^#{dtype}(.*)/) {
								$1.dup.split(' ').each {|p|
									phash[p]= [day, dvalue]
								}
							}
						end
					}
					last = day.to_i + 1
				end
	
				if fp =~ /party.ann$/ 
					s = File.read(LOG_DIR + @vid + '/' + fp)
					{'' => '跺', '' => '', '' => ''}.each {|dtype, dvalue|
						if s.index(dtype)
							s.gsub(/^#{dtype}(.*)/) {
								$1.dup.split(' ').each {|p|
									phash[p]= [last, dvalue]
								}
							}
						end
					}
				end
			}
			['', 'ʤ'].each {|c| phash.delete(c) }
			phash['']= [2, '']
			phash.each {|k, v| phash[k]= [99, '¸'] if v == [] }
			phash
		end
		private :get_ann
	
		def get_person_state(person)
			@phash[person]
		end
	
	end
	
	class Status
		require 'jcode'

		attr_reader :out
	
		def initialize(vid)
			#FIXME!!!! Please refactaring the data structures!!!!
			@vid = vid
			msgs_cnt = {}
			@title = File.read(LOG_DIR + @vid + '/name')
	
			n = '1'
			while true
				begin
					say_cnt, density, total = anlyse_output(n)
					say_cnt.keys.each {|key|
						if msgs_cnt.has_key?(key)
							msgs_cnt[key][0] << say_cnt[key]
							msgs_cnt[key][1] << density[key]
							msgs_cnt[key][2] << total[key]
						else
							msgs_cnt[key] = [[], [], []]
							msgs_cnt[key][0] << say_cnt[key]
							msgs_cnt[key][1] << density[key]
							msgs_cnt[key][2] << total[key]
						end
					}
					n.succ!
				rescue
					break
				end
			end

			# calc avg.
			[0, 1, 2].each {|n|
				msgs_cnt.keys.each {|key|
					t, z = 0, 0
					msgs_cnt[key][n].each {|v|
						t += v
						z += 1 if v == 0
					}
					if t != 0
						msgs_cnt[key][n] << t / ( msgs_cnt[key][n].size - z )
					else  # newtype or not entry
						msgs_cnt.delete(key)
					end
				}
			}

			avg_cnt = {'99' => [[], [], []]}
			m = 0
			while true 
				begin

					#say_cnt == {'01' => 20, '02' => 18 ... }
					#msgs_cnt == {'01' => [[18, 20...], [154, 111...], [...]]}

					exclude = 0 
					msgs_cnt.each {|k, v|
						if v[0][m] != 0
						if avg_cnt['99'][0][m]
									avg_cnt['99'][0][m] += v[0][m]
									avg_cnt['99'][1][m] += v[1][m]
									avg_cnt['99'][2][m] += v[2][m]
							else
								avg_cnt['99'][0][m] = v[0][m]
								avg_cnt['99'][1][m] = v[1][m]
								avg_cnt['99'][2][m] = v[2][m]
							end
						else
							exclude += 1
						end
					}

					j = msgs_cnt.keys.size - exclude
					avg_cnt['99'][0][m] = avg_cnt['99'][0][m] / j
					avg_cnt['99'][1][m] = avg_cnt['99'][1][m] / j
					avg_cnt['99'][2][m] = avg_cnt['99'][2][m] / j

					m += 1
				rescue
					break
				end
			end

			(0..2).each {|n|
				avg_cnt['99'][n].compact!
			}

			erb = ERB.new(File.read(RHTML['status']))
			@out = erb.result(binding)
		end
	
		def anlyse_output(day_id)
			fp = "#{LOG_DIR + @vid}/day#{day_id}.dat"
			day_str = day_id + 'D'
	
			say_cnt = {}
			density = {}
			total = {}
			@log = []
	
			File.read(fp).each {|line| @log << line.chomp.split('<>') }
			@log.each {|ary|
				if ary[2] == 'say'
					if say_cnt.has_key?(ary[1])
						say_cnt[ary[1]] += 1
					else
						say_cnt[ary[1]] = 1
					end
					ary[4].gsub!(/<br \/>/, '..')
					if total.has_key?(ary[1])
						total[ary[1]] += ary[4].jlength
					else
						total[ary[1]] = ary[4].jlength
					end
				end
			}
	
			total.each {|k, v|
				density[k]= v / say_cnt[k] if say_cnt[k] != 0
			}
	
			PERSONS.keys.each {|key|
				say_cnt[key] = 0 unless say_cnt.has_key?(key)
				density[key] = 0 unless density.has_key?(key)
				total[key] = 0 unless total.has_key?(key)
			}

			del_ary = ['01', '99']
			[say_cnt, density, total].each {|hash|
				del_ary.each {|key| hash.delete(key) }
			}
	
			[say_cnt, density, total]
		end
		private :anlyse_output
	end
	
	class Init
		def initialize
			$logger.debug("Init: Welcome, Master? (version.#{SOFTWARE_VERSION})")
			@cgi = CGI.new
			case @cgi.params['mode'][0]
			when 'prt_plus'
				vid = get_vid
				emu = RealTimeEmulate.new(vid)
				day = emu.plus
				redirect("./?vid=#{vid}&day=#{day}")
			when 'prt_end'
				vid = get_vid
				emu = RealTimeEmulate.new(vid)
				emu.quit
				redirect("./?vid=#{vid}")
			when 'castgen'
				castgen = CastGen.new(get_vid)
				$logger.debug("Init: [CAST GENERATE]")
				@cgi.out('text/plain') { castgen.out }
			when 'status'
				status = Status.new(get_vid)
				@cgi.out('text/html') { status.out }
			when 'config'
				config = Config.new
				@cgi.out('text/html') { config.out }
			when 'config_update'
				cfg = Config.new
				cfg.dump(@cgi.params)
				redirect('./?mode=config')
			when 'split'
				spt = Splitter.new('', @cgi.params['vid'][0], @cgi.params['day'][0], @cgi.params['type'][0])
				@cgi.out('text/html') { spt.input }
				exit
			when 'split_sync'
				$logger.debug("Init: [SPLIT SYNC(AJAX)]")
				spt = Splitter.new(NKF.nkf('-e', @cgi.params['body'][0]).gsub(/\n/, "\r\n"))
				@cgi.out(ajax_header) { spt.response }
				$logger.debug("Init: [SPLIT SYNC(AJAX OUT)]")
				exit
			when 'preview'
				if @cgi.has_key?('html')
					say_type = 'html'
				elsif @cgi.has_key?('html_think')
					say_type = 'think'
				elsif @cgi.has_key?('html_whisper')
					say_type = 'whisper'
				end
				spt = Splitter.new(@cgi.params['body'][0], @cgi.params['vid'][0], @cgi.params['day'][0], @cgi.params['type'][0])
				$logger.debug("Init: [PREVIEW]")
				@cgi.out('text/html') { spt.preview(say_type) }
			when 'post'
				cfg = Config.new
				vid = @cgi.params['vid'][0]
				say_type = @cgi.params['type'][0]
				day = @cgi.params['day'][0]
				body = Splitter.new(CGI.unescape(@cgi.params['body'][0]))
				rtype = @cgi.params['rtype'][0]

				case vid
				when /^C/ then uri = SRV_C_URI.sub(/\?/, '')
				when /^F/ then uri = SRV_F_URI.sub(/\?/, '')
				end

				act = Action.new(vid, uri, cfg.get('user'), cfg.get('pass'))
				w = true
				first = true
				body.to_a.each {|msg|
					if first
						first = false
					else
						sleep 19
					end
					w = act.post(msg, say_type)
					break unless w
				}
				if w
					redirect("./?vid=#{vid}&day=#{day}&type=#{rtype}#bottom")
					exit
				else
					redirect("./?mode=error&vid=#{vid}&day=#{day}&type=#{rtype}")
					exit
				end
			when 'download'
				Downloader.new(@cgi.params['vid'][0])
				$logger.debug("Init: [DOWNLOAD=>Redirect] #{@cgi.params['refer'][0]}")
				redirect(@cgi.params['refer'][0])
			when 'update'
				v, d, t, m, s = get_keys
				$logger.debug("Init: [UPDATE(DOWNLOAD)] vid => #{v}, day => #{d}")
				dl = Downloader.new(v)
				if dl.result
					locate = "./?mode=redirect&vid=#{v}&day=#{d}&type=#{t}&refer=#{@cgi.params['refer'][0]}"
					$logger.debug("Init: [UPDATE(AJAX)] Need Refresh. (#{locate})")
					@cgi.out(ajax_header) { locate }
 				else
					$logger.debug("Init: [UPDATE(AJAX)] Not Updated.")
					@cgi.out(ajax_header) { 'no' }
 				end
			when 'redirect'
				v, d, t, m, s = get_keys
				locate = "./?vid=#{v}&day=#{d}&type=#{t}##{@cgi.params['refer'][0]}"
				$logger.debug("Init: [UPDATE(REDIRECT)] => (#{locate})")
				redirect(locate)
			when 'reparse'
				vid = get_vid
				Dir.entries(LOG_DIR + vid + '/').sort.each {|fn|
					if fn =~ /^(day0|\.day0)/
					elsif fn =~ /^(day|\.day|tmp|party)/
						File.unlink(LOG_DIR + vid + '/' + fn)
					else
					end
				}

				Downloader.new(@cgi.params['vid'][0])
				$logger.debug("Init: [REPARSE=>Redirect] #{@cgi.params['refer'][0]}")
				redirect(@cgi.params['refer'][0])
			else
				if @cgi.has_key?('vid') && @cgi.params['vid'][0] != ''
					unless File.exist?(LOG_DIR + @cgi.params['vid'][0])
						$logger.debug("Init: [NO=>Download] #{LOG_DIR + @cgi.params['vid'][0]}")
						Downloader.new(@cgi.params['vid'][0])
					end
					vid, day, type, sword = get_keys
					if @cgi.has_key?('prt') && File.exist?(LOG_DIR + vid + '/.emu') == false
						emu = RealTimeEmulate.new(vid)
						emu.start
						$logger.debug("Init: [NO=>View] RealTime Emulation Started. vid => #{vid}")
					end
					$logger.debug("Init: [NO=>View] vid => #{vid}, day => #{day}")
					if sword != ''
						view = View.new(vid, day, type, sword)
					else
						view = View.new(vid, day, type)
					end
					@cgi.out('text/html') { view.out }
				else
					$logger.debug("Init: [NO=>Index]")
					i = Index.new
					@cgi.out('text/html') { i.out }
				end
			end
		end
	
		def get_keys
			h = {'day' => '0', 'type' => 'white', 'sword' => ''}
			h.each {|k, v| h[k]= @cgi.params[k][0] if @cgi.params.has_key?(k) }
			vid = get_vid
	
			[vid, h['day'], h['type'], h['sword']]
		end

		def get_vid
			if @cgi.params.has_key?('vid') == false
				@cgi.out('text/plain') { "No Village id, No Life." }
				exit
			end
	
			@cgi.params['vid'][0]
		end

		def ajax_header
			{\
				'type' => 'text/plain',
				'charset' => 'euc-jp',
				'cache-control' => 'no-cache',
				'pragma' => 'no-cache'
			}
		end

		def redirect(locate)
			s = %Q(<html><head>)
			s << %Q(<meta http-equiv="Refresh" content="0;URL=#{locate}">)
			s << %Q(</head><body></body></html>)
			c = CGI.new
			c.out('text/html') { s }
		end
	end

	class Config
		def initialize
			@cfg = {}
			@cgi = CGI.new
	
			if File.exist?(SOFTWARE_CONFIG_FN)
				File.read(SOFTWARE_CONFIG_FN).each {|line|
					ary = line.chomp.split(':')
					@cfg[ary[0].strip] = ary[1].strip
				}
			else
			end
		end
	
		def get(key)
			if @cfg.has_key?(key)
				@cfg[key]
			else
				get_default(key)
			end
		end
	
		def get_default(key)
			defaults = {\
				'cast_alive_color' => '',
				'cast_alive_bgcolor' => '',
				'cast_newtype_color' => '',
				'cast_newtype_bgcolor' => 'gray',
				'cast_attack_color' => '',
				'cast_attack_bgcolor' => 'salmon',
				'cast_exe_color' => 'white',
				'cast_exe_bgcolor' => 'black',
	
				'system_css' => 'std.css',
				'preview_face' => '01',
				'groan_img' => false,
				'font_size' => '15',
				'compact_mode' => false,
			}
			if defaults.has_key?(key)
				defaults[key]
			else
				''
			end
		end
	
		def out
			id_ary = [\
				['user_id_c', '桼ID(C)', 'text'],
				['password_c', 'ѥ(C)', 'password'],
				['user_id_f', '桼ID(F)', 'text'],
				['password_f', 'ѥ(F)', 'password'],
			]
			
			cast_ary = [\
				['cast_alive_color', '¸ʸ', 'text'],
				['cast_alive_bgcolor', '¸طʿ', 'text'],
				['cast_newtype_color', 'ʸ', 'text'],
				['cast_newtype_bgcolor', 'طʿ', 'text'],
				['cast_attack_color', 'ֽʸ', 'text'],
				['cast_attack_bgcolor', 'ֽطʿ', 'text'],
				['cast_exe_color', 'ֽ跺ʸ', 'text'],
				['cast_exe_bgcolor', 'ֽ跺طʿ', 'text'],
			]
			
			sys_ary = [\
				['system_css', '륷', 'text'],
				['preview_face', 'ȯץӥ塼δ', preview_face],
				['groan_img', '貼ǤΥ饯λ', 'checkbox'],
				['font_size', 'եȥ', 'text'],
				['compact_mode', '˥塼Υѥɽ', 'checkbox'],
			]
			
			ary = [\
				['ID/Password', id_ary],
				['Cast Generation (for wolfbbs.jp)', cast_ary],
				['System', sys_ary],
			]
	
			erb = ERB.new(File.read(RHTML['config']))
			erb.result(binding)
		end

		def preview_face
			face = get('preview_face')
			x =  %Q(<select name="preview_face">\n)
			ary = []
			PERSONS.each {|k, v| ary << [k, v[1]] }
			ary.sort{|a, b| a[0] <=> b[0] }.each {|a|
				if a[0] == face
					x << %Q(<option value="#{a[0]}" selected>#{a[1]}</option>\n)
				else
					x << %Q(<option value="#{a[0]}">#{a[1]}</option>\n)
				end
			}
			x << %Q(</select>\n)
			x
		end
	
		def dump(c)
			f = ''
			c.each {|k, v| f << k + ': ' + v[0] + "\n" if k != 'mode' }
			File.open(SOFTWARE_CONFIG_FN, 'w') {|fh| fh.write f }
		end
	end
	
	class Index
		def initialize
			vid_dirs = []
			Dir.entries(LOG_DIR).each {|f|
				if File.basename(f) =~ /\d+/
					vid_dirs << f if File.basename(f) != '0'
				end
			}
			@index = vid_dirs.sort
			@config = Config.new
		end 

		def get_id
			ary = []
			ary << 'C: ' + @config.get('user_id_c') if @config.get('user_id_c') != ''
			ary << 'F: ' + @config.get('user_id_f') if @config.get('user_id_f') != ''
			if ary != []
				'[ ' + ary.join(' / ') + ' ]'
			else
				''
			end
		end

		def get_state(vid)
			if File.exist?(LOG_DIR + vid + '/.emu')
				emu = RealTimeEmulate.new(vid)
				"P/RT: #{emu.state.last}"
			else
				path = LOG_DIR + vid + '/'
				dats = Dir.entries(path)
				dats.reject! {|dat| dat !~ /dat$/ }
				dats.sort!
				start = dats.first
				party = dats.last

				begin
					times = []
					times << IO.readlines(path + start).first.split('<>').first
					times << IO.readlines(path + party).last.split('<>').first

					times.collect! {|time| Time.at(time.to_i).strftime("%Y/%m/%d") }
					times[0]
				rescue
					''
				end
			end
		end
	
		def out
			erb = ERB.new(File.read(RHTML['index']))
			erb.result(binding)
		end
	end
end

def debug(str)
	c = CGI.new
	c.out('text/html') { str }
	exit
end

if $0 == __FILE__
	begin
		ZeX::Init.new
	rescue
		c = CGI.new

		x = "An error occured.\n\n"
		x << "Backtrace\n------------------------\n"
		x << "#{$!}\n\n"
		x << %Q(#{$!.backtrace.join("\n")})

		if File.exist?('zex.log')
			x << "\n\n\n"
			x << "ZeX log(last 5 lines)\n------------------------\n"
			log = IO.readlines('zex.log')
			for i in 1..5
				x << log[log.size-i]
			end
		end

		x << "\n\nSystem summary\n------------------------\n"
		x << "Ruby #{RUBY_VERSION} (#{RUBY_PLATFORM})\n"
		x << "#{c.user_agent}\n"
		x << "Zinro eXtension version #{SOFTWARE_VERSION} "
		x << "(with #{c.server_software})"

		c.out('text/plain') { x }
	end
end
